if RequiredScript == "lib/network/base/networkpeer" then
	function NetworkPeer:synced_mods()
		if type(self._mods) ~= "table" then
			self._mods = {}
		end

		table.sort(self._mods, function(a, b)
			return utf8.to_upper(b.name) > utf8.to_upper(a.name)
		end)

		return self._mods
	end
end

-- "name" is the mod name defined in the mod.txt file
-- "id" is the name of the folder where mod.txt is located
-- if you want to change "id" for name just remove the "+ 1" in the insertion to `temp`
-- looking for mods through the name folder is stupid and will not show results in mws the grand majority of times
if RequiredScript == "lib/managers/menu/menucomponentmanager" then
	Hooks:PreHook(MenuComponentManager, "_create_crimenet_contract_gui", "server_mod_list", function(self, node)
		local job_data = node:parameters().menu_component_data
		-- only process server blips
		if not job_data.server then
			return
		end

		-- [string "core/lib/utils/corestring.lua"]:63: bad argument #1 to 'gmatch' (string expected, got nil)
		if type(job_data.mods) ~= "string" then
			-- lobby reported as modded but mod list is nil
			-- build_mod_list() never returns nil, this must be a spoofer
			job_data.mods = table.concat({
				"Error, crash prevented!",
				"empty",
				"Server reported as modded",
				"empty",
				"but no valid mod list was given!",
				"empty",
				"   ",
				"empty",
				"This could be a rare steam matchmake error",
				"empty",
				"or the server is spoofing mods!",
				"empty",
			}, "|") .. "|"
			return
		end

		-- vanilla server
		if job_data.mods == "1" then
			return
		end

		local temp = {}

		local splits = string.split(job_data.mods, "|")
		for i = 1, #splits, 2 do
			table.insert(temp, {
				name = splits[i] or "Error: No Name",
				id = splits[i + 1] or "Error: No ID",
			})
		end

		table.sort(temp, function(a, b)
			return utf8.to_upper(b.name) > utf8.to_upper(a.name)
		end)

		local mods_str = ""
		for _, mod_data in ipairs(temp) do
			mods_str = mods_str .. string.format("%s|%s|", mod_data.name, mod_data.id)
		end

		job_data.mods = mods_str
	end)
end
